#include <iostream>
#include <fstream>

#include <unistd.h>

#include <geos_c.h>

using namespace std;

int main()
{
  initGEOS(0, 0);

  ifstream f( "buffer-tst.txt" );
  if (!f.is_open())
    return 1;

  int count;
  f >> count;
  cout << "count = " << count << endl;

  double x,y;
  GEOSCoordSequence *coord = GEOSCoordSeq_create( count, 2 );
  for ( int i = 0; i < count; i++ )
  {
    f >> x >> y;
    GEOSCoordSeq_setX( coord, i, x );
    GEOSCoordSeq_setY( coord, i, y );
  }

  GEOSGeometry* g = GEOSGeom_createLineString( coord );

  GEOSGeometry* gBuffer = GEOSBuffer(g, 0.013, 5);
  cout << "buffer " << gBuffer << " " << GEOSGeomType(gBuffer) << endl;

  const GEOSGeometry* gBufferRing = GEOSGetExteriorRing( gBuffer );
  const GEOSCoordSequence* coordRing = GEOSGeom_getCoordSeq( gBufferRing );
  unsigned int size;
  GEOSCoordSeq_getSize(coordRing, &size);
  cout << "ring points = " << size << endl;

  GEOSGeom_destroy(g);
  GEOSGeom_destroy(gBuffer);

  finishGEOS();

  cout << "finished" << endl;
  usleep(5000000);

  return 0;
}

